program queue_main
  use mpi_queue
  use my_data_types
  use my_calculations
  implicit none

  ! This initializes the MPI-Library
  call Queue_Init()
  ! This defines the data-types necessary for the master<->slave communication,
  ! see module mpi_data_type
  call Queue_Define_Types()
  ! callback functions: 
  ! defines tasks which are sent to slaves (only called in the master process)
  Queue_Tasks_Initialize => Tasks_Initialize
  ! calculation routine (for slaves)
  Queue_Task_Compute => Task_Compute
  ! reciever routine (for master)
  Queue_Task_Recieve => Task_Recieve
  ! analysis callback (after all Tasks have completed), (for master)
  Queue_Tasks_Analysis => Tasks_Analysis
  ! This starts the queue:
  ! * The master generates the tasks and distributes them to the clients
  ! * The slaves wait for tasks, calculate and return the results to the master
  call Queue_Start()
  ! this finalizes everything (mpi and other data used by the queue)
  call Queue_Finalize()

end program queue_main
